var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { forwardRef } from 'react';
import Highlight, { defaultProps } from 'prism-react-renderer';
import { Box, useLawlietffDefaultProps, useLawlietffTheme, } from '@lawlietff/ui';
import { getPrismTheme } from './prism-theme';
import useStyles from './Prism.styles';
const prismDefaultProps = {
    withLineNumbers: false,
    trim: true,
    highlightLines: {},
};
export const Prism = forwardRef((props, ref) => {
    const _a = useLawlietffDefaultProps('Prism', prismDefaultProps, props), { className, children, language, classNames, styles, withLineNumbers, highlightLines, scrollAreaComponent: ScrollAreaComponent = 'div', colorScheme, trim } = _a, others = __rest(_a, ["className", "children", "language", "classNames", "styles", "withLineNumbers", "highlightLines", "scrollAreaComponent", "colorScheme", "trim"]);
    const code = trim && typeof children === 'string' ? children.trim() : children;
    const maxLineSize = code.split('\n').length.toString().length;
    const theme = useLawlietffTheme();
    const { classes, cx } = useStyles({
        colorScheme: colorScheme || theme.colorScheme,
        native: true,
        maxLineSize,
    }, { classNames, styles, name: 'Prism' });
    return (React.createElement(Box, Object.assign({ className: cx(classes.root, className), ref: ref }, others),
        React.createElement(Highlight, Object.assign({}, defaultProps, { theme: getPrismTheme(theme, colorScheme || theme.colorScheme), code: code, language: language }), ({ className: inheritedClassName, style: inheritedStyle, tokens, getLineProps, getTokenProps, }) => (React.createElement(ScrollAreaComponent, { className: classes.scrollArea, dir: "ltr" },
            React.createElement("pre", { className: cx(classes.code, inheritedClassName), style: inheritedStyle, dir: "ltr" }, tokens
                .map((line, index) => {
                var _a, _b, _c, _d;
                if (index === tokens.length - 1
                    && line.length === 1
                    && line[0].content === '\n')
                    return null;
                const lineNumber = index + 1;
                const lineProps = getLineProps({ line, key: index });
                const shouldHighlight = lineNumber in highlightLines;
                const lineColor = theme.colorScheme === 'dark'
                    ? theme.fn.rgba(theme.fn.themeColor((_a = highlightLines[lineNumber]) === null || _a === void 0 ? void 0 : _a.color, 9), 0.25)
                    : theme.fn.themeColor((_b = highlightLines[lineNumber]) === null || _b === void 0 ? void 0 : _b.color, 0);
                return (React.createElement("div", Object.assign({ key: index }, lineProps, { className: cx(classes.line, lineProps.className), style: Object.assign({}, (shouldHighlight ? { backgroundColor: lineColor } : null)) }),
                    withLineNumbers && (React.createElement("div", { className: classes.lineNumber, style: {
                            color: shouldHighlight
                                ? theme.fn.themeColor((_c = highlightLines[lineNumber]) === null || _c === void 0 ? void 0 : _c.color, theme.colorScheme === 'dark' ? 5 : 8)
                                : undefined,
                        } }, ((_d = highlightLines[lineNumber]) === null || _d === void 0 ? void 0 : _d.label) || lineNumber)),
                    React.createElement("div", { className: classes.lineContent }, line.map((token, key) => {
                        var _a, _b;
                        const tokenProps = getTokenProps({ token, key });
                        return (React.createElement("span", Object.assign({ key: key }, tokenProps, { style: Object.assign(Object.assign({}, tokenProps.style), { color: shouldHighlight
                                    ? theme.fn.themeColor((_a = highlightLines[lineNumber]) === null || _a === void 0 ? void 0 : _a.color, theme.colorScheme === 'dark' ? 5 : 8)
                                    : (_b = tokenProps === null || tokenProps === void 0 ? void 0 : tokenProps.style) === null || _b === void 0 ? void 0 : _b.color }) })));
                    }))));
            })
                .filter(Boolean)))))));
});
Prism.displayName = '@lawlietff/prism/Prism';
